SystemOrganization addCategory: #TAdP!
SystemOrganization addCategory: #'TAdP-Tests'!

Trait named: #TraitConsumoCable
	uses: {}
	category: 'TAdP'!

!TraitConsumoCable methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:41'!
consumo:unPanel
	^unPanel consumo * (self getAumento)! !

!TraitConsumoCable methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:43'!
getAumento
	self requirement.! !

Trait named: #TraitPanelConsumo
	uses: {}
	category: 'TAdP'!

!TraitPanelConsumo methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:36'!
consumo
	^(self getPotencia * self getTamanio).! !

!TraitPanelConsumo methodsFor: 'as yet unclassified' stamp: 'joseflores 4/18/2013 02:11'!
getPotencia
	^self requirement.! !

!TraitPanelConsumo methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:00'!
getTamanio
	^self requirement.! !

Trait named: #TraitPanelDefinicion
	uses: {}
	category: 'TAdP'!

!TraitPanelDefinicion methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:37'!
definicion
	^(self getPPP * ((self getTamanio raisedTo: 2) / 2) sqrt).
	! !

!TraitPanelDefinicion methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:22'!
getPPP
	self requirement.
	! !

!TraitPanelDefinicion methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:21'!
getTamanio
	self requirement.
	! !

TestCase subclass: #PanelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP-Tests'!

!PanelTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:40'!
testConsumoLED
	| unPanel |
	unPanel  := LED new.
	unPanel setTamanio: 32.
	unPanel setPotencia: 4.
		
	self assert: (128 = unPanel consumo)! !

!PanelTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:25'!
testDefMaxCRT
	| unPanel |
	unPanel  := CRT new.
	unPanel setTamanio: 32.
	
	self assert: (480= unPanel definicion)! !

!PanelTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:31'!
testDefMaxLED
	| unPanel |
	unPanel  := LED new.
	unPanel setTamanio: 32.
	unPanel setPPP:1080.
	
	self assert: (24437 = unPanel definicion floor)! !

TestCase subclass: #ProductoTest
	instanceVariableNames: 'unProducto unPanel unCable'
	classVariableNames: 'Argument'
	poolDictionaries: ''
	category: 'TAdP-Tests'!

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 01:25'!
testConsumoDeUnProductoLEDConHDMI
	unProducto := Producto new.
	unPanel  := LED new.
	unCable := HDMI new.
	unPanel setPotencia: 4.
	unPanel setTamanio: 42.
	unPanel setPPP:1080.
		
	unProducto setPanel: unPanel.
	unProducto setCable: unCable.
	
	self assert:(168 = unPanel consumo).
	self assert:(369 = unProducto consumo floor).! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 01:00'!
testConsumoDeUnProductoLEDConVGA
	unProducto := Producto new.
	unPanel  := LED new.
	unCable := VGA new.
	unPanel setPotencia: 4.
	unPanel setTamanio: 42.
	unPanel setPPP:1080.
		
	unProducto setPanel: unPanel.
	unProducto setCable: unCable.
	
	self assert:(168 = unPanel consumo).
	self assert:(168 = unProducto consumo floor).! !

Object subclass: #Cable
	instanceVariableNames: 'hz definicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

Cable subclass: #AV
	uses: TraitConsumoCable
	instanceVariableNames: ''
	classVariableNames: 'aumento'
	poolDictionaries: ''
	category: 'TAdP'!

AV class
	uses: TraitConsumoCable classTrait
	instanceVariableNames: ''!

!AV class methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:42'!
getAumento
	^aumento.! !

!AV methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:41'!
getAumento
	^self class getAumento.! !

!Cable methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:53'!
getDefinicion
	^definicion.! !

!Cable methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:53'!
getHz
	^hz.! !

Cable subclass: #HDMI
	uses: TraitConsumoCable
	instanceVariableNames: ''
	classVariableNames: 'aumento'
	poolDictionaries: ''
	category: 'TAdP'!

!HDMI commentStamp: '<historical>' prior: 0!
A HDMI is xxxxxxxxx.

Instance Variables
!

HDMI class
	uses: TraitConsumoCable classTrait
	instanceVariableNames: ''!

!HDMI class methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 01:17'!
getAumento
	^1.2.! !

!HDMI methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:42'!
getAumento
	^self class getAumento.! !

Cable subclass: #RF
	uses: TraitConsumoCable
	instanceVariableNames: ''
	classVariableNames: 'aumento'
	poolDictionaries: ''
	category: 'TAdP'!

!RF commentStamp: '<historical>' prior: 0!
A RF is xxxxxxxxx.

Instance Variables
!

RF class
	uses: TraitConsumoCable classTrait
	instanceVariableNames: ''!

!RF class methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 01:16'!
getAumento
	^0.! !

!RF methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:42'!
getAumento
	^self class getAumento.! !

!RF methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:54'!
getDefinicion
	^480.! !

Cable subclass: #VGA
	instanceVariableNames: ''
	classVariableNames: 'aumento'
	poolDictionaries: ''
	category: 'TAdP'!

!VGA commentStamp: '<historical>' prior: 0!
A VGA is xxxxxxxxx.

Instance Variables
!

!VGA class methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:59'!
getAumento
	aumento isNil ifTrue: [aumento:=0.001].
	^aumento.! !

!VGA methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:59'!
consumo:unPanel
	^(self getAumento * ((unPanel definicion) min: (self getDefinicion))).! !

!VGA methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:42'!
getAumento
	^self class getAumento.! !

!VGA methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:54'!
getDefinicion
	^480.! !

Object subclass: #Computadora
	instanceVariableNames: 'imagen video disco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!Computadora commentStamp: '<historical>' prior: 0!
A Computadora is xxxxxxxxx.

Instance Variables
	disco:		<Object>
	imagen:		<Object>
	video:		<Object>

disco
	- xxxxx

imagen
	- xxxxx

video
	- xxxxx
!

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 23:03'!
consumo
	^(self getDisco consumo) + (self getImagen consumo) + (self getVideo consumo:(self getImagen)).! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 23:00'!
esAptaParaJugar
	^(self getImagen esAptoParaJugar) && (self getGPU esApta:(self getImagen)).! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 23:00'!
getDisco
	^disco.! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:59'!
getImagen
	^imagen.! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 23:00'!
getVideo
	^video.! !

Object subclass: #Disco
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

Disco subclass: #DiscoEstadoSolido
	instanceVariableNames: 'consumoFijo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!DiscoEstadoSolido commentStamp: '<historical>' prior: 0!
A DiscoEstadoSolido is xxxxxxxxx.

Instance Variables
	consumoFijo:		<Object>

consumoFijo
	- xxxxx
!

!DiscoEstadoSolido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:32'!
consumo
	^self getConsumo.! !

!DiscoEstadoSolido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:32'!
getConsumo
	^consumoFijo.! !

!DiscoEstadoSolido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:32'!
setConsumo:unValor
	consumoFijo := unValor.! !

Disco subclass: #DiscoRigido
	instanceVariableNames: 'rpm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!DiscoRigido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:31'!
consumo
	^self getRpm * 60 / 1000.! !

!DiscoRigido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:30'!
getRpm
	^rpm.! !

!DiscoRigido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:30'!
setRpm:unValor
	rpm := unValor.! !

Object subclass: #GPU
	instanceVariableNames: 'coolers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!GPU methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:06'!
consumoCoolers! !

!GPU methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:12'!
consumoGPU:unProducto
	^self consumo:unProducto + self consumoCoolers.! !

!GPU methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:07'!
getCoolers
	^coolers.! !

!GPU methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:09'!
setCoolers:unValor
	coolers := unValor.! !

GPU subclass: #GPUBasica
	instanceVariableNames: 'consumoPromedio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!GPUBasica methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:12'!
consumo:unProducto
	^((self resolucionReal:unProducto) logaritmo / self getConsumoPromedio).! !

!GPUBasica methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:50'!
esApta:unProducto
	^((unProducto resolucionPermitida * (unProducto resolucionPermitida * 9 / 16) ) / self getConsumoPromedio) > 4.
	
	! !

!GPUBasica methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:56'!
getConsumoPromedio
	^consumoPromedio.! !

!GPUBasica methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:02'!
resolucionReal:unProducto
	^unProducto resolucionPermitida.! !

!GPUBasica methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:56'!
setConsumoPromedio:unValor
	consumoPromedio := unValor.! !

GPU subclass: #GPUModerna
	instanceVariableNames: 'ancho alto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!GPUModerna methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:00'!
consumo:unProducto
	^self resolucionReal:unProducto / 100000.! !

!GPUModerna methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:48'!
esApta:unProducto.
	^true.! !

!GPUModerna methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:50'!
resolucionMaxima
	^self getAncho * self getAlto.! !

!GPUModerna methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:00'!
resolucionReal:unProducto
	^(unProducto resolucionPermitida min: self resolucionMaxima).! !

GPU subclass: #GPUOnboard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!GPUOnboard methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:14'!
consumo:unProducto
	^self getConsumoPromedio.! !

!GPUOnboard methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:48'!
esApta:unProducto
	^false.! !

Object subclass: #Panel
	instanceVariableNames: 'potencia tamanio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

Panel subclass: #CRT
	uses: TraitPanelConsumo
	instanceVariableNames: ''
	classVariableNames: 'definicionMax'
	poolDictionaries: ''
	category: 'TAdP'!

CRT class
	uses: TraitPanelConsumo classTrait
	instanceVariableNames: ''!

!CRT class methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:49'!
definicion
	^self class definicionMaxima.! !

!CRT class methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:25'!
getDefinicionMaxima
	definicionMax isNil ifTrue: [definicionMax:=480].
	^definicionMax.! !

!CRT methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:51'!
definicion
	^self class getDefinicionMaxima.! !

Panel subclass: #LCD
	uses: TraitPanelConsumo + TraitPanelDefinicion
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

LCD class
	uses: TraitPanelConsumo classTrait + TraitPanelDefinicion classTrait
	instanceVariableNames: ''!

!LCD methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:52'!
getPPP
	^ppp.! !

!LCD methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:52'!
setPPP:unValor
	ppp := unValor.! !

Panel subclass: #LED
	uses: TraitPanelConsumo + TraitPanelDefinicion
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

LED class
	uses: TraitPanelConsumo classTrait + TraitPanelDefinicion classTrait
	instanceVariableNames: ''!

!LED methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:53'!
getPPP
	^ppp.! !

!LED methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:53'!
setPPP:unValor
	ppp := unValor.! !

!Panel methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:50'!
getPotencia
	^potencia.! !

!Panel methodsFor: 'Getter/Setter' stamp: 'joseflores 4/18/2013 08:25'!
getTamanio
	^tamanio.! !

!Panel methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:51'!
setPotencia:unValor
	potencia := unValor.! !

!Panel methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:51'!
setTamanio:unValor
	tamanio := unValor.! !

Object subclass: #Producto
	instanceVariableNames: 'cable panel'
	classVariableNames: 'hz'
	poolDictionaries: ''
	category: 'TAdP'!

Producto subclass: #Moni
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!Producto class methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:27'!
getHz
	^hz.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'joseflores 4/18/2013 22:07'!
consumo
	^((self getCable consumo:((self getPanel))) + ((self getPanel) consumo)).! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:57'!
esAptoParaJugar
	^self tasaDeRefrescoReal >= 100.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'joseflores 4/18/2013 01:57'!
getCable
	^cable.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:27'!
getHz
	^self class getHz.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'joseflores 4/18/2013 01:57'!
getPanel
	^panel.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:46'!
resolucionPermitida
	^(self getCable getDefinicion) min: (self getPanel definicion)! !

!Producto methodsFor: 'as yet unclassified' stamp: 'joseflores 4/18/2013 01:55'!
setCable:unCable
	cable:= unCable.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:25'!
setHz:unValor
	hz := unValor.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:19'!
setPanel:unPanel
	panel := unPanel.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:58'!
tasaDeRefrescoReal
	^(self class getHz) min: (self getCable getHz).! !

Producto subclass: #TV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

TV subclass: #SmartTV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!SmartTV methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:28'!
getHz
	^self super class getHz * 1,5.! !
